
#include <iostream>
#include <pngwriter.h>
#include <string>
using namespace std;


class CORRELATION
{
	public:
		CORRELATION(const char *izq, const char *der, const char *output);
		void maximizar();							// maximizar C2
		void minimizar();							// minimizar C1
		void mediana();
		void fillin();
		void fillin2();
		void contraste();
		void filtraInputs();
		void setsize();
		void setsize(int a, int b);
		void guardar();
		
	private:
		void filtro(pngwriter &im, string name);
		float calcularC1(int x, int y, int d, pngwriter &I, pngwriter &D);	// basada en diferencia
		float calcularC2(int x, int y, int d, pngwriter &I, pngwriter &D);	// basada en multiplicacion
		pngwriter Imagen, izq, der;
		int X;
		int Y;
		string nizq, nder;
		const static int WSIZEX = 7;				// Tamaño de ventana de correlación
		const static int WSIZEY = 7;				// Tamaño de ventana de correlación
		const static int WSEARCH = 10*WSIZEX;		// Tamaño de ventana de busqueda
};
